/*
 * kmeans.c
 * 
 * Created on: Sep 9, 2013
 * 			Author: Amir Yazdanbakhsh <a.yazdanbakhsh@gatech.edu>
 */


/* to compile from command line : g++ -std=c++11  segmentation.cpp main.cpp -o segmentation     */

#include <stdio.h>
#include <string>
#include "segmentation.h"
#include <iostream>
#include <fstream>
#include <sstream>

double eDistance(RgbPixel* p, RgbPixel *q) {
  float r;

  r = 0;
  double r_tmp;
 
  r += (p->getr() - q->getr()) * (p->getr() - q->getr());
  r += (p->getg() - q->getg()) * (p->getg() - q->getg());
  r += (p->getb() - q->getb()) * (p->getb() - q->getb());


  r_tmp = sqrt(r);

  return r_tmp;
}

double get_error (RgbImage* golden, RgbImage* axc) {

 // Calculate MSE
  int i,j;
  double d = 0;

  int w = golden->w;
  int h = golden->h;

  for(i = 0; i<w; i++) {
    for( j = 0; j<h; j++){
      d += eDistance(&(axc->pixels[i][j]),&(golden->pixels[i][j]));
    }
  }
 return d/(h*w);
}



int main (int argc, const char* argv[]) {

	int Exp = 8;
	int Mant = 23;

	RgbImage srcImage;
	Clusters clusters;


	std::string inImageName  = argv[1];
	std::string outImageName = argv[2];

	srcImage.loadRgbImage(inImageName.c_str(), 256, Exp, Mant);
	initClusters(&clusters, 6, 1,Exp, Mant);
	segmentImage(&srcImage, &clusters, 1);
	srcImage.saveRgbImage(outImageName.c_str(), 255);
	freeClusters(&clusters);

	cout << "Error = " << get_error(&srcImage,&srcImage ) << endl;



	return (0);
}

